/* vi: set sw=4 ts=4: */

/* no getopt needed */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <regex.h>
#include <sys/types.h>



/* 
expr.c: reduced for muLinux 
*/

/*
 * Copyright (C) 1997
 *      Michele Andreoli, Pontedera (PISA) Italy.  All rights reserved.
 */

#define APPLET expr

#define USAGE "Syntax 1: expr X [-|+|/|*|%] Y \n\
Syntax 2 (conversions): expr [o|x|c|d] X\n\
Syntax 3 (bits ops): expr X [|&<>^] Y\n\
"
const char expr_usage[]=USAGE;

typedef unsigned long ulong;


int expr_main (int argc, char **argv)
{
long x=0,y=0;
char *op=NULL;

/* Parsing */

switch ( argc )
{
case 3:	{ 
	op=argv[1];
	x=strtol( (const char*)(argv[2]),0,0);
	break;
	}
case 4:
	{
	x=strtol( (const char*)(argv[1]),0,0);
	op=argv[2];
	y=strtol( (const char*)(argv[3]),0,0);
        break;
        }
default: {fprintf(stderr,"%s",USAGE) ;exit(1);}
}


/* operate */

switch( op[0] )
{
/* aritmetic */
case '+':	{printf("%ld\n",x+y); break;}
case '-':	{printf("%ld\n",x-y); break;}
case '*':	{printf("%ld\n",x*y); break;}
case '%':	{printf("%ld\n",x%y); break;}
case '/':	
		{
		//printf("%ld\n",(ulong) (div(x,y)).quot); 
		printf("%ld\n",(ulong) x/y); 
		break;}
/* bits */
case '&':	{printf("%ld\n",x&y); break;}
case '|':	{printf("%ld\n",x|y); break;}
case '^':	{printf("%ld\n",x^y); break;}
case '<':	{printf("%ld\n",x<<y); break;}
case '>':	{printf("%ld\n",x>>y); break;}

/* binary conversion */
case '~':	{printf("%i\n",~x); break;}
case 'o':	{printf("%0o\n",x); break;}
case 'x':	{printf("%0x\n",x); break;}
case 'd':	{printf("%0ld\n",x); break;}
case 'c':	{putchar(atoi(argv[2])); putchar('\n'); break;}

}


return(0);
}
