#define APPLET timeout

/*        
timeout.c: execute command under timeout
condition. If no commands are specified, it wait
for a key pressed.
Syntax:

		# timeout seconds
or
		# timeout seconds "cmd arg1 arg2 ..."		


(C)1999-2000 M. Andreoli	

 */

#include <signal.h>
#include <unistd.h>
#include <stdio.h>

void alarm_signal(int);

char key[5];
int to;
char *cmd;
int pid=0,status;

timeout_main(int argc, char **argv)
{
/* syntax */
if (argv[1] == NULL )
{
fprintf(stderr,"Usage: timeout [seconds] [command args ...]\n");
exit(1);
}
to=atoi(argv[1]); /* seconds to wait */
if (argv[2] != NULL )
	cmd=argv[2];
else
	cmd=(char*) 0;

/* install signal handler */
signal(SIGALRM,alarm_signal);

/* set alarm() */
alarm(0);
alarm(to);

if ( cmd == NULL ) {
	/* called with a single timeout argument */
	read(0,key,1);
	exit(1);
}  else {
	status=system(cmd);
	/*
	 system() return 127 if we have an execve error;
	-1 other errors; otherwise the command return code.
	We assume timeout also in case of error.
	*/
	if ( status == 0 ) {
	exit(1);  /* no timeout */
	} else exit(0);
}


}

void alarm_signal(int sig)
{
fprintf(stderr,"timeout\n");
exit(0);  /* timeout */
}
